﻿package {

	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;

	public class IntuitiveDrawer extends Sprite {

		var bg:BitmapData;
		var container:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var square:Sprite;
		var lineStack:Array;
		var matrix:Matrix;
		var clickA:Array = new Array();
		var clickB:Array = new Array();

		var counter:uint;
		var angler:Number;
		var wangler:Number;
		var distance_reel:Number;
		var checkmouse:uint;
		var ratios:Array;

		public function IntuitiveDrawer():void {

			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xFFFFFF);
			container = new Bitmap(bg);
			addChild(container);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);

		}
		private function startDessine(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(10,0xcccccc,0.5);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY));
		}
		private function dessine(e:MouseEvent):void {
			if (line != null) {
				clickB.push(new Array(e.stageX,e.stageY));
				addChild(line);
			}
		}
		private function stopDessine(e:MouseEvent):void {

			if (line != null) {
				removeChild(line);
				line = null;
				clickB.push(new Array(e.stageX,e.stageY));
				circularArea();
				checkmouse = mouseX;
				angler = Math.atan2(clickB[0][1]+distance_reel,clickB[0][0]+distance_reel);
				wangler = Math.PI*angler;
				clickB = [];
				counter = 0;
			}
		}
		public function circularArea():void {
			if(square){removeChild(square);}
			var distanceX:Number=clickB[0][0]-clickB[clickB.length-1][0];
			var distanceY:Number=clickB[0][1]-clickB[clickB.length-1][1];
			distance_reel = Math.sqrt(distanceX*distanceX+distanceY*distanceY);
			square = new Sprite();
			square.graphics.beginFill(buildColor(),0.2);
			square.graphics.moveTo(clickB[0][0],clickB[0][1]);
			square.graphics.lineTo(clickB[0][0]+distance_reel,clickB[0][1]+distance_reel);
			square.graphics.lineTo(clickB[clickB.length-1][0],clickB[clickB.length-1][1]);
			square.graphics.lineTo(clickB[clickB.length-1][0]-distance_reel,clickB[clickB.length-1][1]-distance_reel);
			square.graphics.lineTo(clickB[0][0],clickB[0][1]);


			square.graphics.endFill();
			addChild(square);


			addEventListener(Event.ENTER_FRAME,floodit);
		}
		private function floodit(e:Event):void {
			counter +=1;

			if (counter<200) {
				bg.draw(square,matrix);
				matrix.rotate(270);
				matrix.scale(1.0001,1.01);
			}

		}
		private function buildColor():uint {
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var A:uint = Math.round(Math.random()*100);
			var nbr:uint = R << 16 | G << 8 | B;
			return nbr;
		}
	}
}